<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\CodePhysicRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\CodePhysic;
use App\SystemPhysic;
use App\CodePhyscal;
use App\Physical;

class CodePhyscalController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/codephyscals';
    /** View folder */
    private $viewDirectory= 'admin.codephyscals.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('codephyscals.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the codephyscals.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = CodePhysic::orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $codephyscals= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('codephyscals'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('codephyscals.store');
        $head = metaFields('codephyscals', 'add_new', getCurrentLocale()) ?? __('codephyscals.new');
        $systemphysics = SystemPhysic::all();
       

        return view( $this->viewDirectory.'form', compact('action', 'head','systemphysics') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CodePhysicRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(CodePhysicRequest $request) :RedirectResponse
    {
     
        $codephyscal= CodePhysic::create($request->all());
        $this->saveData( $request, $codephyscal->id );
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Code  $codephyscal
     * @return View
     */
    public function edit(CodePhysic $codephyscal): View
    {
        $action= route('codephyscals.update', $codephyscal->id);
        $head = metaFields('codephyscals', 'edit', getCurrentLocale()) ?? __('codephyscals.edit');
        $systemphysics = SystemPhysic::all();
        $physcals = CodePhyscal::where('code_id',$codephyscal->id)->get();
        $physcaling = Physical::cursor();


        return view( $this->viewDirectory.'form', compact('codephyscal', 'action', 'head','systemphysics','physcals','physcaling') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  CodePhysicRequest  $request
     * @param  Code  $systemfood
     * @return RedirectResponse|Redirector
     */
        public function update(CodePhysicRequest $request, CodePhysic $codephyscal) :RedirectResponse
    {
      
        $codephyscal->update($request->all());
        CodePhyscal::where('code_id',$codephyscal->id)->delete();
        $this->saveData( $request, $codephyscal->id );
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
     private function saveData(CodePhysicRequest $request, int $codephyscal_id ):void
    {
        $requestData= $request->all();
        foreach ($request->physcal as $row) {
            $data=[
                'code_id'=> $codephyscal_id,
                'physcal_id'=> $row['physcal_id'],

            ];
            CodePhyscal::create($data);
        }

        

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = CodePhysic::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            CodePhysic::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            CodePhysic::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = CodePhysic::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = CodePhysic::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
